Subject: Re: [RFC PATCH bpf-next v5 2/2] net: Add additional bit to support clockid_t timestamp type

From: Martin KaFai Lau <[email-masked]>
Date: Fri, 26 Apr 2024 16:50:59 -0700

On 4/26/24 11:46 AM, Abhishek Chauhan (ABC) wrote:
>>> diff --git a/net/ipv4/ip_output.c b/net/ipv4/ip_output.c
>>> index 591226dcde26..f195b31d6e75 100644
>>> --- a/net/ipv4/ip_output.c
>>> +++ b/net/ipv4/ip_output.c
>>> @@ -1457,7 +1457,7 @@ struct sk_buff *__ip_make_skb(struct sock *sk,
>>>          skb->priority = (cork->tos != -1) ? cork->priority: READ_ONCE(sk->sk_priority);
>>>        skb->mark = cork->mark;
>>> -    skb->tstamp = cork->transmit_time;
>>> +    skb_set_tstamp_type_frm_clkid(skb, cork->transmit_time, sk->sk_clockid);
>> hmm... I think this will break for tcp. This sequence in particular:
>>
>> tcp_v4_timewait_ack()
>>    tcp_v4_send_ack()
>>      ip_send_unicast_reply()
>>        ip_push_pending_frames()
>>          ip_finish_skb()
>>            __ip_make_skb()
>>              /* sk_clockid is REAL but cork->transmit_time should be in mono */
>>              skb_set_tstamp_type_frm_clkid(skb, cork->transmit_time, sk->sk_clockid);;
>>
>> I think I hit it from time to time when running the test in this patch set.
>>
> do you think i need to check for protocol type here . since tcp uses Mono and the rest according to the new design is based on
> sk->sk_clockid
> if (iph->protocol == IPPROTO_TCP)
> 	skb_set_tstamp_type_frm_clkid(skb, cork->transmit_time, CLOCK_MONOTONIC);
> else
> 	skb_set_tstamp_type_frm_clkid(skb, cork->transmit_time, sk->sk_clockid);

Looks ok. iph->protocol is from sk->sk_protocol. I would defer to Willem input here.

There is at least one more place that needs this protocol check, __ip6_make_skb().